import dune.codegen.sumfact.geometry

from dune.codegen.generation import get_backend
from dune.codegen.options import option_switch
from dune.codegen.pdelab.argument import (name_applycontainer,
                                          name_coefficientcontainer,
                                          )

import dune.codegen.sumfact.accumulation
import dune.codegen.sumfact.switch

from dune.codegen.pdelab import PDELabInterface


class SumFactInterface(PDELabInterface):
    def get_accumulation_info(self, expr, visitor):
        from dune.codegen.sumfact.accumulation import get_accumulation_info
        return get_accumulation_info(expr, visitor)

    def list_accumulation_infos(self, expr, visitor):
        from dune.codegen.sumfact.accumulation import list_accumulation_infos
        return list_accumulation_infos(expr, visitor)

    def generate_accumulation_instruction(self, expr, visitor):
        from dune.codegen.sumfact.accumulation import generate_accumulation_instruction
        return generate_accumulation_instruction(expr, visitor)
